

#include "args.h"
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

void help(void);

// TODO some arguments are not implemented but still can be selected.
void parse(char const **argv, int arc, my_args_t *args)
{
    args->lazyEncoding = 1; // default
    for (int i = 1; i < arc; i++)
    {
        if (strcmp("--threads", argv[i]) == 0)
        {
            i++;
            args->threads = atoi(argv[i]);
            continue;
        }

        if (strcmp("--check", argv[i]) == 0)
        {
            args->check = 1;
            continue;
        }

        if (strcmp("--static", argv[i]) == 0)
        {
            args->staticClause = 1;
            continue;
        }

        if (strcmp("--printLearned", argv[i]) == 0)
        {
            args->printLearnedClauses = 1;
            continue;
        }

        if (strcmp("--timeout", argv[i]) == 0) // print assignment at the given decision lvl
        {
            i++;
            args->timeout = atoi(argv[i]);
            continue;
        }

        if (strcmp("--frequency", argv[i]) == 0)
        {
            i++;
            args->frequency = atoi(argv[i]);
            continue;
        }

        if (strcmp("--debug", argv[i]) == 0) // prints for each edge the unmapped literal and the mapped literal
        {
            args->debug = 1;
            continue;
        }

        if (strcmp("--trans", argv[i]) == 0 || strcmp("-k", argv[i]) == 0) // exact number of disjoint transversals
        {
            i++;
            args->maxTransversals = atoi(argv[i]);
            args->minTransversals = args->maxTransversals;
            continue;
        }

        if (strcmp("--maxTransversals", argv[i]) == 0)
        {
            i++;
            args->maxTransversals = atoi(argv[i]);
            continue;
        }

        if (strcmp("--girth", argv[i]) == 0) // each k-subset must be in independent se
        {
            i++;
            args->girth = atoi(argv[i]);
            if (args->girth == 2) // trivially satisfied
                args->girth = 0;
            continue;
        }

        if (strcmp("--minTransversals", argv[i]) == 0) // minimum number of transversals, which we can assume
        {
            i++;
            args->minTransversals = atoi(argv[i]);
            continue;
        }

        if (strcmp("--printClauses", argv[i]) == 0) // prints for each edge the unmapped literal and the mapped literal
        {
            args->printClauses = 1;
            continue;
        }

        if (strcmp("--oriented", argv[i]) == 0) // prints for each edge the unmapped literal and the mapped literal
        {
            args->oriented = 1;
            continue;
        }

        if (strcmp("--verify", argv[i]) == 0) // prints for each edge the unmapped literal and the mapped literal
        {
            args->verify = 1;
            continue;
        }

        if (strcmp("--assumption", argv[i]) == 0)
        {
            i++;
            args->assumptionFile = argv[i];
            args->noRestarts = 1;
            continue;
        }

        if (strcmp("--assumptionLine", argv[i]) == 0) // which line should be used starting with 1
        {
            i++;
            args->assumptionLine = atoi(argv[i]);
            continue;
        }

        if (strcmp("-o", argv[i]) == 0)
        {
            i++;
            args->clauseFile = fopen(argv[i], "w");
            if (!args->clauseFile)
            {
                printf("c\tERROR: Not able to write to given file\n");
            }
            continue;
        }

        if (strcmp("--lazy", argv[i]) == 0) // each k-subset must be in independent se
        {
            i++;
            args->lazyEncoding = atoi(argv[i]);
            continue;
        }

        if (strcmp("--addSingleClause", argv[i]) == 0) // each k-subset must be in independent se
        {
            args->addSingleClause = 1;
            continue;
        }

        if (strcmp("--clingo", argv[i]) == 0)
        {
            i++;
            args->optionsClingo = &argv[i];
            args->nOptions = arc - i;
            return;
        }

        printf("ERROR: invalid argument %s\n", argv[i]);
        help();
        exit(1);
    }
}

void help()
{
    printf("For options see file argparse.c\n");
}