#include "solver.h"
#include "util.h"

#define INITIAL_SIZE_CLAUSE_LIST (1 << 27)
#define INITIAL_SIZE_INTEGER_LIST (1 << 4)

// returns the position where added

void addLiteral(clauses_state_t *state, lit_t lit, truth_value_t *assignment);
void removeLiteral(clauses_state_t *state, lit_t lit, truth_value_t *assignment);

clause_t *addNewClause(clauses_state_t *state, truth_value_t *assignment, int b1, int b2, int e, int *literals, int size);
void removeClause(clauses_state_t *state, int index);

int addElemToIntList(int_list_t *list, int elem);

void checkState(clauses_state_t *state, truth_value_t *assignment, propagator_t *data); // function to test whether the current state is correct (Brute force check)

// second version
void addLiteral2(clauses_state_t *state, lit_t lit, truth_value_t *assignment);
void removeLiteral2(clauses_state_t *state, lit_t lit, truth_value_t *assignment);

clause_t *addNewClause2(clauses_state_t *state, truth_value_t *assignment, int b1, int b2, int e, int *literals, int size);
void removeClause2(clauses_state_t *state, int index);

int addElemToIntList2(int_list_t *list, int elem);

void checkState2(clauses_state_t *state, truth_value_t *assignment, propagator_t *data); // function to test whether the current state is correct (Brute force check)

// checks if really ready to fire
void updateReady2fire(clauses_state_t *state, clause_t *clause, truth_value_t *assignment, int index);