#ifndef __UTIL
#define __UTIL

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <assert.h>

#define ABS(x) (x > 0 ? x : -x)
#define MIN(x, y) ((x) < (y) ? x : y)
#define MAX(x, y) ((x) < (y) ? y : x)

#define SWAP(a, p1, p2)   \
    {                     \
        int temp = a[p1]; \
        a[p1] = a[p2];    \
        a[p2] = temp;     \
    }

#define CHECK_OUT_OF_MEMORY(data)                                            \
    {                                                                        \
        if (!data)                                                           \
        {                                                                    \
            printf("Out of memory. Line %d, file %s\n", __LINE__, __FILE__); \
            exit(EXIT_FAILURE);                                              \
        }                                                                    \
    }

#define DEBUG_MSG                                             \
    {                                                         \
        if (1)                                                \
            printf("Line %d, file %s\n", __LINE__, __FILE__); \
        fflush(stdout);                                       \
    }

#define EXIT_UNWANTED_STATE                                                          \
    {                                                                                \
        printf("Error: unexpected state at line %d, file %s\n", __LINE__, __FILE__); \
        exit(EXIT_FAILURE);                                                          \
    }

typedef struct
{
    void **elements; // list of pointers to elements
    int nElems;
    int maxElements;
} list_t;

void bubbleSort(int arr[], int n);

int containsElement(int *list, int n, int elem);

#endif // __UTIL